# ECM Spoofer Project

This project creates a Raspberry Pi Zero W-based device that spoofs a 2013 Camaro SS ECM over OBD2 using a PiCAN2 interface.

## Project Structure

```
ecm-spoofer/
├── src/
│   └── ecm_spoofer.py       # Main ECM spoofer script
├── config/
│   └── can_interface.conf   # CAN interface configuration
├── scripts/
│   ├── setup.py             # Dependency installation and setup
│   └── deploy.py            # Deployment script for Raspberry Pi
└── docs/
    └── README.md            # Project documentation
```

## Setup Instructions

1. Clone this repository to your local machine
2. Run `python3 setup.py` to install dependencies
3. Configure your Raspberry Pi's CAN interface
4. Run the spoofer script with `python3 src/ecm_spoofer.py`

## Dependencies

### Hardware
- Raspberry Pi Zero W
- PiCAN2 CAN-Bus Interface
- 12V to 5V power regulator
- OBD2 to DB9 cable

### Software
- Raspberry Pi OS Lite
- Python 3
- python-can